/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TImportConfig.TImportConfigPath;
import de.ship.db.tables.records.TImportConfigRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TImportConfig extends TableImpl<TImportConfigRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_import_config</code>
     */
    public static final TImportConfig T_IMPORT_CONFIG = new TImportConfig();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TImportConfigRecord> getRecordType() {
        return TImportConfigRecord.class;
    }

    /**
     * The column <code>common_dd.t_import_config.lastchange</code>.
     */
    public final TableField<TImportConfigRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_import_config.pk</code>. the used id, act as
     * primary key
     */
    public final TableField<TImportConfigRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "the used id, act as primary key");

    /**
     * The column <code>common_dd.t_import_config.fk_import_config</code>. the
     * id from parent
     */
    public final TableField<TImportConfigRecord, Integer> FK_IMPORT_CONFIG = createField(DSL.name("fk_import_config"), SQLDataType.INTEGER, this, "the id from parent");

    /**
     * The column <code>common_dd.t_import_config.name</code>. name of config
     * item
     */
    public final TableField<TImportConfigRecord, String> NAME = createField(DSL.name("name"), SQLDataType.CLOB.nullable(false), this, "name of config item");

    /**
     * The column <code>common_dd.t_import_config.value</code>. value of config
     * item
     */
    public final TableField<TImportConfigRecord, String> VALUE = createField(DSL.name("value"), SQLDataType.CLOB.nullable(false), this, "value of config item");

    private TImportConfig(Name alias, Table<TImportConfigRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TImportConfig(Name alias, Table<TImportConfigRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_import_config</code> table reference
     */
    public TImportConfig(String alias) {
        this(DSL.name(alias), T_IMPORT_CONFIG);
    }

    /**
     * Create an aliased <code>common_dd.t_import_config</code> table reference
     */
    public TImportConfig(Name alias) {
        this(alias, T_IMPORT_CONFIG);
    }

    /**
     * Create a <code>common_dd.t_import_config</code> table reference
     */
    public TImportConfig() {
        this(DSL.name("t_import_config"), null);
    }

    public <O extends Record> TImportConfig(Table<O> path, ForeignKey<O, TImportConfigRecord> childPath, InverseForeignKey<O, TImportConfigRecord> parentPath) {
        super(path, childPath, parentPath, T_IMPORT_CONFIG);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TImportConfigPath extends TImportConfig implements Path<TImportConfigRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TImportConfigPath(Table<O> path, ForeignKey<O, TImportConfigRecord> childPath, InverseForeignKey<O, TImportConfigRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TImportConfigPath(Name alias, Table<TImportConfigRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TImportConfigPath as(String alias) {
            return new TImportConfigPath(DSL.name(alias), this);
        }

        @Override
        public TImportConfigPath as(Name alias) {
            return new TImportConfigPath(alias, this);
        }

        @Override
        public TImportConfigPath as(Table<?> alias) {
            return new TImportConfigPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TImportConfigRecord, Integer> getIdentity() {
        return (Identity<TImportConfigRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TImportConfigRecord> getPrimaryKey() {
        return Keys.PK_IMPORT_CONFIG;
    }

    @Override
    public List<ForeignKey<TImportConfigRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_IMPORT_CONFIG__FK_IMPORT_CONFIG);
    }

    private transient TImportConfigPath _tImportConfig;

    /**
     * Get the implicit join path to the <code>common_dd.t_import_config</code>
     * table.
     */
    public TImportConfigPath tImportConfig() {
        if (_tImportConfig == null)
            _tImportConfig = new TImportConfigPath(this, Keys.T_IMPORT_CONFIG__FK_IMPORT_CONFIG, null);

        return _tImportConfig;
    }

    @Override
    public TImportConfig as(String alias) {
        return new TImportConfig(DSL.name(alias), this);
    }

    @Override
    public TImportConfig as(Name alias) {
        return new TImportConfig(alias, this);
    }

    @Override
    public TImportConfig as(Table<?> alias) {
        return new TImportConfig(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TImportConfig rename(String name) {
        return new TImportConfig(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TImportConfig rename(Name name) {
        return new TImportConfig(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TImportConfig rename(Table<?> name) {
        return new TImportConfig(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TImportConfig where(Condition condition) {
        return new TImportConfig(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TImportConfig where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TImportConfig where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TImportConfig where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TImportConfig where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TImportConfig where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TImportConfig where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TImportConfig where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TImportConfig whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TImportConfig whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
